#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u2-2

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"


NUMBER_OF_STEPS=2
CURRENT_STEP=0
PASSED_STEPS=0

#PRIPRAVA SUBOROV
touch tmp_file.txt

echo
echo "Testovanie ulohy u2-2 z cvicenia 3"
echo

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e stat -o $STRACE_OUTPUT ./$TESTED_PROGRAM tmp_file.txt > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test(){

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby na ziskanie informacii o subore"
if grep -q -e "^stat(\"tmp_file.txt\"," $STRACE_OUTPUT; then
	echo "OK - Sluzba stat() bola zavolana so spravnymi parametrami."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na na ziskanie informacii o subore nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zistenia a vypisania inode"
#zisti i-node 
INODE_EXPECTED=$(stat --printf='%i' tmp_file.txt)
INODE_FOUND=$(awk '{ print $4 }' tested_program_output.txt)

if [ $INODE_EXPECTED -eq $INODE_FOUND ]
	then
		echo "OK - Vypisany inode suboru."
		((PASSED_STEPS+=1))
	else 
		cho "CHYBA - Nebol vypisany inode."
fi

}


#ZAVOLANIE TESTU
test

#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."
echo

if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		echo
		echo "Zaznamy o teste su ulozene v suboroch:"
		echo "$STRACE_OUTPUT"
		echo "$TESTED_PROGRAM_OUTPUT"
		echo
fi

#MAZANIE VYTVORENYCH SUBOROV
rm tmp_file.txt