#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u3-2

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"


NUMBER_OF_STEPS=5
CURRENT_STEP=0
PASSED_STEPS=0

#PRIPRAVA SUBOROV


echo
echo "Testovanie ulohy u3-2 z cvicenia 3"
echo

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e chdir,openat,getdents,mkdir,lseek -o $STRACE_OUTPUT ./$TESTED_PROGRAM  > $TESTED_PROGRAM_OUTPUT 2>&1

#PRIPRAVA TESTOV
test(){

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie nastavenia pracovného adresára"
if grep -q -e "^chdir(\"u3-2-dir\")" $STRACE_OUTPUT; then
	echo "OK - Sluzba chdir() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na nastavenie pracovného adresára nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby opendir()"
if grep -q -e "^openat(AT_FDCWD, \"\.\", O_RDONLY|O_NONBLOCK|O_CLOEXEC|O_DIRECTORY)" $STRACE_OUTPUT; then
	echo "OK - Sluzba opendir() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba opendir() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby readdir()"
if grep -q -e "^getdents" $STRACE_OUTPUT; then
	echo "OK - Sluzba readdir() bola zavolana."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba readdir() nebola zavolana."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie vytvorenia adresara."
if grep -q -e "^mkdir(\"dir2\", 0700)" $STRACE_OUTPUT; then
	echo "OK - Sluzba mkdir() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba mkdir() nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zavolania sluzby rewinddir."
if grep -q -e "^lseek(., 0, SEEK_SET)" $STRACE_OUTPUT; then
	echo "OK - Sluzba rewinddir() bola zavolana."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba rewinddir() nebola zavolana."
fi

}

#ZAVOLANIE TESTU
test

#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."
echo

if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		echo
		echo "Zaznamy o teste su ulozene v suboroch:"
		echo "$STRACE_OUTPUT"
		echo "$TESTED_PROGRAM_OUTPUT"
		echo
fi

#MAZANIE VYTVORENYCH SUBOROV
rmdir u3-2-dir/dir2