#!/bin/bash

#NASTAVENIE PREMENNYCH
#TESTED_PROGRAM=$1
TESTED_PROGRAM=u6-4

TESTED_PROGRAM_OUTPUT=tested_program_output.txt
STRACE_OUTPUT="strace_out.txt"


NUMBER_OF_STEPS=4
CURRENT_STEP=0
PASSED_STEPS=0

#PRIPRAVA SUBOROV
echo "na zaciatku prava 577" > file13Test.txt;
chmod 577 file13Test.txt;
mkdir dir05Test;
chmod 676 dir05Test


echo
echo "Testovanie ulohy u6-3 z cvicenia 3"
echo



#PRIPRAVA TESTOV
test(){

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e stat,chmod -o $STRACE_OUTPUT ./$TESTED_PROGRAM file13Test.txt > $TESTED_PROGRAM_OUTPUT 2>&1


((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie ziskania informacii o subore"
if grep -q -e "^stat(\"file13Test.txt\"" $STRACE_OUTPUT; then
	echo "OK - Sluzba stat() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na ziskanie informacii o subore nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zmeny prav suboru"
if grep -q -e "^chmod(\"file13Test.txt\", 0100755) " $STRACE_OUTPUT; then
	echo "OK - Sluzba chmod() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na zmenu prav nebola zavolana alebo jej boli zadane nespravne parametre."
fi

#SPUSTENIE TESTOVANEHO PROGRAMU - ZISKANIE VYPISU VOLANYCH SLUZIEB
strace -e stat,chmod -o $STRACE_OUTPUT ./$TESTED_PROGRAM dir05Test > $TESTED_PROGRAM_OUTPUT 2>&1

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie ziskania informacii o adresari"
if grep -q -e "^stat(\"dir05Test\"" $STRACE_OUTPUT; then
	echo "OK - Sluzba stat() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na ziskanie informacii o adresari nebola zavolana alebo jej boli zadane nespravne parametre."
fi

((CURRENT_STEP+=1))
echo "TEST $CURRENT_STEP / $NUMBER_OF_STEPS Testovanie zmeny prav adresara"
if grep -q -e "^chmod(\"dir05Test\", 040766)" $STRACE_OUTPUT; then
	echo "OK - Sluzba chmod() bola zavolana so spravnym parametrom."
	((PASSED_STEPS+=1))
else	
	echo "CHYBA - Sluzba na zmenu prav nebola zavolana alebo jej boli zadane nespravne parametre."
fi

}

#ZAVOLANIE TESTU
test

#VYHODNOTENIE TESTU
echo
echo Vysledok testovania
echo "Uspesne bolo vykonanych $PASSED_STEPS / $NUMBER_OF_STEPS testov."
echo

if [ $PASSED_STEPS -eq $NUMBER_OF_STEPS ]
	then
		#ZMAZE SUBORY SO ZAZNAMAMI TESTOV
		rm $TESTED_PROGRAM_OUTPUT 
		rm $STRACE_OUTPUT
	else 
		echo
		echo "Zaznamy o teste su ulozene v suboroch:"
		echo "$STRACE_OUTPUT"
		echo "$TESTED_PROGRAM_OUTPUT"
		echo
fi

#MAZANIE VYTVORENYCH SUBOROV
rm file13Test.txt
rmdir dir05Test